-- 图腾图鉴
Lua_TotemHandbookWindow = class("Lua_TotemHandbookWindow", Lua_Window)
function Lua_TotemHandbookWindow:ctor()
	self:superCall("ctor");
	
	self.windowName = "Lua_TotemHandbookWindow";
	self.skinName = "TotemHandbookWindow_skin";
	self.showBlackMask = true;
	self.isClickClose = true;
end

function Lua_TotemHandbookWindow:buildShowItem()
	self:superCall("buildShowItem");
	self.checkHelp:addClickFuntion(self, self.onCheckHelpClick);

	self.itemList = Lua_DragList.new(self.content, 630, 750, Lua_AxisDefine.Vertical);
	self.itemList:setLocation(0, -71, 0);
	self.itemList:setListCell(Lua_TotemHandbookItem, 630, 148, 1);
	self.itemList:setCellSpacing(0, 5);

	local arr = DataCenter.totemUtil:getHangbookArr();
	self.itemList:setArrayData(arr);
end

function Lua_TotemHandbookWindow:dispose()
	if self.itemList then
		self.itemList:dispose();
		self.itemList = nil;
	end
	self:superCall("dispose");
end

function Lua_TotemHandbookWindow:onCheckHelpClick(go)
	Lua_WindowUtil.openWin("Lua_InstructionTipsWindow", Lua_WinParam.ACTION_OPEN, { des = LanUtil.getValue(762047), posX = 180, posY = 220, needAdapt = false });
end










Lua_TotemHandbookItem = class("Lua_TotemHandbookItem", Lua_ListCell)
function Lua_TotemHandbookItem:ctor(p)
	self:superCall("ctor", p, "TotemHandbookItem_skin");
end

function Lua_TotemHandbookItem:buildShowItem()
	self:superCall("buildShowItem");
	self.checkIcon:addClickFuntion(self, self.onCheckSuitEff);
end

function Lua_TotemHandbookItem:dispose()
	self.data = nil;
	self:superCall("dispose");
end

function Lua_TotemHandbookItem:setData(data)
	self.data = data;
	
	data = DataCenter.totemUtil:getHangbookConfig(data);
	self.nameText.text = data.name;
	self.icon:setAltas("totem_atlas", data.sprite);

	local arr = DataCenter.packData:getUnIdList(Lua_PackDefine.TOTEM, data.id);
	self.countText.text = LanUtil.formateStr(762012, tostring(arr:getSize()));
	self.desText.text = data.des;
end

function Lua_TotemHandbookItem:onCheckSuitEff(go)
	Lua_WindowUtil.openWin("Lua_TotemSuitEffectWindow", Lua_WinParam.ACTION_OPEN, self.data);
end