Lua_TotemItemDetailsWindow = class("Lua_TotemItemDetailsWindow", Lua_Window)
function Lua_TotemItemDetailsWindow:ctor()
	self:superCall("ctor");
	
	self.layer = Lua_MainWinDefine.TIPS_WINDOW_LAYER;
	self.windowName = "Lua_TotemItemDetailsWindow";
	self.skinName = "TotemItemDetailsWindow_skin";
	self.showBlackMask = true;
	self.isClickClose = true;
end

function Lua_TotemItemDetailsWindow:buildShowItem()
	self:superCall("buildShowItem");
	self.attrItems = Array();

	self.scoreNum = Lua_NumberImage.new(self.showObject);
	self.scoreNum:setLocation(-67, -85.5, 0);
	self.scoreNum.pivot = 1;
	self.scoreNum.numOffsetX = -2;
	self.scoreNum.numAtlas = "number";
	self.scoreNum.preStr = "xui_zl1_number_0";

	self.btnStrengthen:setLangValue(309022);
	self.btnStrengthen:addClickFuntion(self, self.onStrengthenClick);
	self.btnSynthesis:addClickFuntion(self, self.onSynthesisClick);
	self.btnWear:addClickFuntion(self, self.onWearClick);
end

function Lua_TotemItemDetailsWindow:dispose()
	if self.attrItems then
		self.attrItems:dispose();
		self.attrItems:clear();
		self.attrItems = nil;
	end
	if self.scoreNum then
		self.scoreNum:dispose();
		self.scoreNum = nil;
	end
	if self.starList then
		self.starList:dispose();
		self.starList:clear();
		self.starList = nil;
	end
	if self.curSuit then
		self.curSuit:dispose();
		self.curSuit = nil;
	end
	if self.nextSuit then
		self.nextSuit:dispose();
		self.nextSuit = nil;
	end
	self.data = nil;
	self.lvCfg = nil;
	self:superCall("dispose");
	Lua_MsgUtil.callFunc("ITEM_DETAILS_CLOSE")
end

function Lua_TotemItemDetailsWindow:showWin(param)
	self:superCall("showWin", param);
	self.data = param.data;
	self.wearHeroUId = DataCenter.totemData:getHeroUidByTotem(self.data.unique_id);
	self.btnType = param.btnType;

	local level = self.data.strengthenLv;
	self.lvCfg = DataCenter.totemUtil:getLevelConfig(self.data.id, level);
	if level > 0 then
		self.levelBg:setEnable(true);
		self.levelText:setEnable(true);
		self.levelText.text = LanUtil.formateStr(10049, tostring(level));
	else
		self.levelBg:setEnable(false);
		self.levelText:setEnable(false);
	end

	local width = 545;
	local height = 135;
	self.winBg:setAltas("common_altas_2", "xui_common_itembg_"..(self.data.color + 6));
	self.itemIcon:setAltas(self.data.atlas, self.data.sprite);
	self.itemIcon.name = self.data.id;
	self:showStar(self.data.star);

	local colorStr = Lua_ColorDefine.getItemColorStr(self.data.color, true);
	self.nameText.colorStr = Lua_ColorDefine.transColorStr(colorStr);
	self.nameText.text = self.data.name;
	self.posText.text = LanUtil.formateStr(762000, convert_arab_to_chinese(self.data.part));
	self.scoreNum.num = self.data.score;

	local len = self.attrItems:getSize();
	for i = 1, len do
		self.attrItems[i]:setEnable(false);
	end
	local addH = 40;
	local startY = -139.5;
	local index = 1;
	local item;

	self.mainTitle:setEnable(true);
	local attrArr = DataCenter.totemData:getMainAttrArr(self.data);
	len = attrArr:getSize();
	for i = 1, len do
		item = self:createAttrItem(index);
		item:setLocation(-250, startY - addH - (i - 1) * 40, 0);
		if attrArr[i].nextValue > 0 then
			str = LanUtil.formateStr(762025, attrArr[i].show_name, attrArr[i].showValue, attrArr[i].showNextValue);
		else
			str = LanUtil.formateStr(762024, attrArr[i].show_name, attrArr[i].showValue);
		end
		item:setData("common_altas_2", attrArr[i].attr_icon_2, str);

		index = index + 1;
	end
	addH = addH + len * 40;

	self.randomTitle:setEnable(true);
	self.randomTitle:setLocation(-250, startY - addH, 0);
	addH = addH + 40;

	attrArr = DataCenter.totemData:getRandomAttrArr(self.data);
	if attrArr == nil then
		item = self:createAttrItem(index);
		item:setLocation(-250, startY - addH, 0);
		item:setData(nil, nil, DataCenter.totemUtil:getRandomAttrLangId(self.data.star));
		index = index + 1;
		addH = addH + 40;
	else
		len = attrArr:getSize();
		for i = 1, len do
			item = self:createAttrItem(index);
			item:setLocation(-250, startY - addH - (i - 1) * 40, 0);
			if attrArr[i].nextValue > 0 then
				str = LanUtil.formateStr(762025, attrArr[i].show_name, attrArr[i].showValue, attrArr[i].showNextValue);
			else
				str = LanUtil.formateStr(762024, attrArr[i].show_name, attrArr[i].showValue);
			end
			item:setData("common_altas_2", attrArr[i].attr_icon_2, str);
			index = index + 1;
		end
		addH = addH + len * 40;
	end

	self.suitTitle:setEnable(true);
	self.suitTitle:setLocation(-250, startY - addH, 0);
	addH = addH + 40;

	if self.suitItem == nil then
		self.suitItem = Lua_TotemItemSuitItem.new(self.showObject);
	end
	self.suitItem:setLocation(0, startY - addH, 0);
	addH = addH + self.suitItem:setData(self.data, param.totemInfo);
	addH = addH + 20;

	self.desText:setEnable(true);
	self.desText:setLocation(0, startY - addH, 0);
	addH = addH + 30;

	if param.isShowBtns then
		self.btnObject:SetActive(true);
		if self.btnType == 1 then -- 英雄详情展示界面
			self.btnStrengthen:setEnable(false);
			self.btnSynthesis:setLangValue(309020);
			self.btnSynthesis:setLocation(-120, -56, 0);
			self.btnWear:setLangValue(309021);
			self.btnWear:setLocation(120, -56, 0);
		else
			if self.wearHeroUId == 0 then
				self.btnSynthesis:setLangValue(309012);
				self.btnWear:setLangValue(309016);
			else
				self.btnSynthesis:setLangValue(309020);
				self.btnWear:setLangValue(309021);
			end
		end
		LuaUtil.setObjPos(self.btnObject, 0, startY - addH, 0);
		addH = addH + 110;
	else
		self.btnObject:SetActive(false);
	end

	height = height + addH;
	self.winBg:SetDimensions(width, height);
	LuaUtil.setObjPos(self.showObject, 0, height / 2, 0);
end

function Lua_TotemItemDetailsWindow:createAttrItem(index)
	local item = self.attrItems[index];
	if item == nil then
		item = Lua_AttrIconItem.new(self.showObject);
		item.pivot = 1;
		item.spacingX = 10;
		self.attrItems:add(item);
	else
		item:setEnable(true);
	end
	return item;
end

function Lua_TotemItemDetailsWindow:showStar(num)
	if self.starList == nil then
		self.starList = Array();
	end
	num = num or 0;
	local len = self.starList:getSize();
	local maxLen = num > len and num or len;
	local icon;
	for i = 1, maxLen do
		icon = self.starList[i];
		if i > num then
			if icon then
				icon:setEnable(false);
			end
		else
			if icon == nil then
				icon = UICreate.createUIAtlasImage(self.showObject, "common_altas_1", "xui_common_label_09", 0, 0, 0, 0);
				self.starList:add(icon);
			else
				icon:setEnable(true);
			end
		end
	end
	if num > 0 then
		local space = 10
		local w = -(space * num) / 2 + space / 2
		for i = 1, num do
			icon = self.starList[i]
			icon:setLocation(-195 + ((i - 1) % num) * space + w, -94, 0)
		end
	end
end

function Lua_TotemItemDetailsWindow:onStrengthenClick(go)
	Lua_WindowUtil.openWin("Lua_TotemStrengthenWindow", Lua_WinParam.ACTION_OPEN, self.data);
end

function Lua_TotemItemDetailsWindow:onSynthesisClick(go)
	if self.wearHeroUId == 0 then
		Lua_WindowUtil.openWin("Lua_TotemSynthesisWindow", Lua_WinParam.ACTION_OPEN);
	else
		Lua_WindowUtil.openWin("Lua_TotemReplaceWindow", Lua_WinParam.ACTION_OPEN, { data = self.data, heroUid = self.showData.heroUid });
	end
end

function Lua_TotemItemDetailsWindow:onWearClick(go)
	if self.wearHeroUId == 0 then
		DataCenter.funcPathUtil:gotoFunction(1033, true);
	else
		local arr = Array();
		arr:add(self.data.unique_id);
		Lua_ProxyManager.getProxy("Lua_TotemProxy"):sRemove(self.wearHeroUId, arr);
	end
end










Lua_TotemItemSuitItem = class("Lua_TotemItemSuitItem", Lua_DisplayObject)
function Lua_TotemItemSuitItem:ctor(p)
	self:superCall("ctor", p, "TotemItemSuitItem_skin");
end

function Lua_TotemItemSuitItem:buildShowItem()
	self:superCall("buildShowItem");
	self.desList = Array();
end

function Lua_TotemItemSuitItem:dispose()
	if self.desList then
		self.desList:dispose();
		self.desList:clear();
		self.desList = nil;
	end
	self:superCall("dispose");
end

function Lua_TotemItemSuitItem:setData(data, totemInfo)
	local activeDic = {};
	if totemInfo == nil then
		self.titleText.text = LanUtil.formateStr(762044, tostring(data.suitAmount));
	else
		local num = DataCenter.totemData:getHeroWearNum(totemInfo, data.suitId);
		self.titleText.text = LanUtil.formateStr(762045, tostring(data.suitAmount), tostring(num), tostring(data.suitAmount));

		local suitId;
		for i = 1, #totemInfo.suit_list do
			suitId = totemInfo.suit_list[i];
			activeDic[suitId] = 1;
		end
	end

	local dataLen = data.suitList:getSize();
	local len = self.desList:getSize();
	local maxLen = dataLen > len and dataLen or len;
	local desText;
	local config;
	local str;
	local height = 0;
	for i = 1, maxLen do
		desText = self.desList[i];
		if i > dataLen then
			if desText then
				desText:setEnable(false);
			end
		else
			if desText == nil then
				desText = UICreate.createLabel(self.content, nil, 0, 0, 420, 31, 22);
				desText.alignmentValue = 0;
				desText.pivotValue = 0;
				desText.horizontalOverflowValue = 0;
				desText.verticalOverflowValue = 1;
				self.desList:add(desText);
			else
				desText:setEnable(true);
			end
			desText:setLocation(-235, -11.5 - height, 0);
			config = DataCenter.totemUtil:getSuitConfig(data.suitList[i]);
			str = LanUtil.formateStr(762046, tostring(config.level), Lua_SpaceDefine.SPACE, config.des);
			if activeDic[config.id] == 1 then
				desText.colorStr = Lua_ColorDefine.transColor("66DF57");
			else
				desText.colorStr = Lua_ColorDefine.transColor("85868B");
			end
			desText.text = str;

			desText:resetSize();
			height = height + desText.height + 10;
		end
	end

	desText = self.desList[dataLen];
	return Mathf.Abs(desText.posY) + desText.height;
end