-- 图腾筛选
Lua_TotemScreenWindow = class("Lua_TotemScreenWindow", Lua_Window)
function Lua_TotemScreenWindow:ctor()
	self:superCall("ctor");

	self.w = 130;
	self.h = 181;
	self.layer = Lua_MainWinDefine.TIPS_WINDOW_LAYER;
	self.windowName = "Lua_TotemScreenWindow";
	self.isFullSizeWin = true;
	self.showBlackMask = true;
	self.isClickClose = true;
	self.blackAlpha = 0.01;
	self.showWinBg = true;
	self.winBgAtlas = "totem_atlas";
	self.winBgSprite = "xui_hbtt_widget_26";
end

function Lua_TotemScreenWindow:buildShowItem()
	self:superCall("buildShowItem");
	self.winBg.anchorValue = 4;
	self.winBg.pivotValue = 4;
end

function Lua_TotemScreenWindow:dispose()
	if self.itemList then
		self.itemList:dispose();
		self.itemList = nil;
	end
	self:superCall("dispose");
end

function Lua_TotemScreenWindow:onScreenResize()
	self:superCall("onScreenResize");
	if self.showData.needAdapt == true then
		local posX = self.showData.px;
		local posY = self.showData.py + self.adaptHeight / 2;
		self.winBg:setLocation(posX, posY, 0);
		if self.itemList then
			self.itemList:setLocation(posX, posY, 0);
		end
	end
end

function Lua_TotemScreenWindow:showWin(param)
	self:superCall("showWin", param);
	local posX = param.px;
	local posY = param.needAdapt == true and param.py + self.adaptHeight / 2 or param.py;
	self.winBg:setLocation(posX, posY, 0);

	if self.itemList == nil then
		self.itemList = Lua_DragList.new(self.content, 123, self.h - 11, Lua_AxisDefine.Vertical);
		self.itemList:setLocation(posX, posY, 0);
		self.itemList:setListCell(Lua_TotemScreenItem, 123, 38, 1);
	end
	self.itemList:setArrayData(param.list);

	local selectIdx;
	for i = 1, #param.list do
		if param.list[i] == param.selected then
			selectIdx = i;
			break;
		end
	end
	selectIdx = selectIdx or 1;
	self.itemList:moveToIndex(selectIdx, true);
	self.itemList:setSelected(selectIdx);
end










Lua_TotemScreenItem = class("Lua_TotemScreenItem", Lua_ListCell)
function Lua_TotemScreenItem:ctor(p)
	self:superCall("ctor", p, "TotemScreenItem_skin");
end

function Lua_TotemScreenItem:buildShowItem()
	self:superCall("buildShowItem");
end

function Lua_TotemScreenItem:dispose()
	self.data = nil;
	self:superCall("dispose");
end

function Lua_TotemScreenItem:setData(data)
	self.data = data;
	self.nameText.text = data[2];
end

function Lua_TotemScreenItem:onSelectionChange(bSelected)
	self:superCall("onSelectionChange", bSelected);
	if bSelected then
		self.bg:setEnable(true);
		self.nameText.colorStr = Lua_ColorDefine.transColorStr("FFFFFF");
	else
		self.bg:setEnable(false);
		self.nameText.colorStr = Lua_ColorDefine.transColorStr("9E9A9C");
	end
end

function Lua_TotemScreenItem:onPressClick()
	Lua_MsgUtil.callFunc("TOTEM_SCREEN_SELECT", self.data);
	Lua_WindowUtil.openWin("Lua_TotemScreenWindow", Lua_WinParam.ACTION_CLOSE);
	return true;
end