-- 图腾套装效果
Lua_TotemSuitEffectWindow = class("Lua_TotemSuitEffectWindow", Lua_Window)
function Lua_TotemSuitEffectWindow:ctor()
	self:superCall("ctor");
	
	self.windowName = "Lua_TotemSuitEffectWindow";
	self.skinName = "TotemSuitEffectWindow_skin";
	self.showBlackMask = true;
	self.isClickClose = true;
end

function Lua_TotemSuitEffectWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.itemList = Lua_DragContainer.new(self.content, 380, 325, Lua_AxisDefine.Vertical)
	self.itemList:setLocation(0, -25, 0)
end

function Lua_TotemSuitEffectWindow:dispose()
	if self.itemList then
		self.itemList:dispose();
		self.itemList = nil;
	end
	self:superCall("dispose");
end

function Lua_TotemSuitEffectWindow:showWin(param)
	self:superCall("showWin", param);

	param = DataCenter.totemUtil:getHangbookConfig(param);
	param = param.suits;
	self.itemList:clearList();
	for i = 1, #param do
		self.itemList:addSubContainer(Lua_TotemSuitEffectItem, param[i], false);
	end
	self.itemList:updateChildPos();
	self.itemList.canDrag = not self.itemList.isTheEnd;
end










Lua_TotemSuitEffectItem = class("Lua_TotemSuitEffectItem", Lua_DragContainerItem)
function Lua_TotemSuitEffectItem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_TotemSuitEffectItem:buildShowItem()
	self:superCall("buildShowItem");

	self.levelText = UICreate.createLabel(self.content, nil, -180, 0, 100, 31, 22);
	self.levelText.anchorValue = 1;
	self.levelText.pivotValue = 0;
	self.levelText.alignmentValue = 0;
	self.levelText.horizontalOverflowValue = 1;
	self.levelText.verticalOverflowValue = 1;
	self.levelText.colorStr = Lua_ColorDefine.transColorStr("EDEEF7");

	self.desText = UICreate.createLabel(self.content, nil, -110, 0, 290, 31, 22);
	self.desText.anchorValue = 1;
	self.desText.pivotValue = 0;
	self.desText.alignmentValue = 0;
	self.desText.horizontalOverflowValue = 0;
	self.desText.verticalOverflowValue = 1;
	self.desText.colorStr = Lua_ColorDefine.transColorStr("EDEEF7");
end

function Lua_TotemSuitEffectItem:dispose()
	self.levelText = nil;
	self.desText = nil;
	self:superCall("dispose");
end

function Lua_TotemSuitEffectItem:getWidth()
    return 380;
end

function Lua_TotemSuitEffectItem:getHeight()
    return self.desText.height + 10;
end

function Lua_TotemSuitEffectItem:setData(data)
	data = DataCenter.totemUtil:getSuitConfig(data);
	self.levelText.text = LanUtil.formateStr(10041, tostring(data.level));
	self.desText.text = data.des;
	self.desText:resetSize();
end