Lua_TotemStrengthenPanel = class("Lua_TotemStrengthenPanel", Lua_DisplayObject)
function Lua_TotemStrengthenPanel:ctor(p)
	self:superCall("ctor", p, "TotemStrengthenPanel_skin");
end

function Lua_TotemStrengthenPanel:buildShowItem()
	self:superCall("buildShowItem");
	self:addLuaEvent("MONEY_UPDATE", self, self.onMoneyUpdate);
	self:addLuaEvent("TOTEM_STRENGTHEN_SUCCESS", self, self.updateShowInfo);
	self:addLuaEvent("TOTEM_SCREEN_SELECT", self, self.updateMaterials);
    self:addLuaEvent("TOTEM_STRENGTHEN_PLUS", self, self.onMaterialPlus);
    self:addLuaEvent("TOTEM_STRENGTHEN_LESS", self, self.onMaterialLess);

	self.attrItems = Array();
    self.selectedDic = {};

	self.itemIcon = Lua_ItemIcon.new(self.content);
	self.itemIcon:setLocation(-204, 213, 0);

	self.showBar.typeValue = 3;
	self.showBar.fillMethodValue = 0;
	self.showBar.fillOrigin = 0;
	self.screenBg:addClickFuntion(self, self.onScreenClick);
	self.screenBtn:addClickFuntion(self, self.onScreenClick);
	self.btnChoose:addClickFuntion(self, self.onChooseClick);
	self.btnSure:addClickFuntion(self, self.onSureClick);
end

function Lua_TotemStrengthenPanel:dispose()
	if self.attrItems then
		self.attrItems:dispose();
		self.attrItems:clear();
		self.attrItems = nil;
	end
	if self.itemIcon then
		self.itemIcon:dispose();
		self.itemIcon = nil;
	end
	if self.itemList then
		self.itemList:dispose();
		self.itemList = nil;
	end
	if self.materialArr then
		self.materialArr:clear();
		self.materialArr = nil;
	end
	self.selectedDic = nil;
	self.data = nil;
	self.lvCfg = nil;
	self:superCall("dispose");
end

function Lua_TotemStrengthenPanel:onMoneyUpdate(dic)
	if self.lvCfg == nil then
		return;
	end

	local id = self.lvCfg.cost_item[1];
	if dic == nil or dic[id] == nil then
		return;
	end
	self:updateConsume();
end

function Lua_TotemStrengthenPanel:setData(data)
	self.data = data;
	self:updateShowInfo();
end

function Lua_TotemStrengthenPanel:updateShowInfo()
	local vo = DataCenter.totemData:getTotemItemVo(self.data.unique_id);
	if vo ~= nil then
		self.data = vo;
	end
	self.itemIcon:setData(self.data);
	self.scoreText.text = LanUtil.formateStr(762003, tostring(self.data.score));

	self.upLevel = self.data.strengthenLv;
	if self.upLevel > 0 then
		self.levelText:setEnable(true);
		self.levelText.text = LanUtil.formateStr(762011, tostring(self.upLevel));
	else
		self.levelText:setEnable(false);
	end

	self.curExp = self.data.totem_info ~= nil and self.data.totem_info.exp or 0;
	self.showExp = self.curExp;
	self.lvCfg = DataCenter.totemUtil:getLevelConfig(self.data.id, self.upLevel);
	if self.lvCfg.exp and self.lvCfg.exp > 0 then
		self.needExp = self.lvCfg.exp - self.curExp;
	else
		self.needExp = 0;
	end
    self.addExp = 0; -- 增加的经验
    self.returnCostNum = 0; -- 返回的消耗
    self.costNum = 0; -- 总消耗
	self:updateExpBar();
	
	local arr = DataCenter.totemData:getMainAttrArr(self.data);
	local idx = 1;
	idx = self:showAttr(arr, idx);
	arr = DataCenter.totemData:getRandomAttrArr(self.data);
	self:showAttr(arr, idx);

	local data
	if self.screenData == nil then
		local list = DataCenter.totemUtil.starScreen;
		data = list[1];
	else
		data = self.screenData;
		self.screenData = nil;
	end
	self:updateMaterials(data);
end

function Lua_TotemStrengthenPanel:showAttr(arr, idx)
	if arr then
		local item;
		local str;
		for i = 1, arr:getSize() do
			item = self.attrItems[idx];
			if item == nil then
				item = Lua_AttrIconItem.new(self.content);
				item.pivot = 1;
				item.spacingX = 10;
				item:setTextStyle(Lua_MyUISettings.huakangFontName, 24);
				self.attrItems:add(item);
			else
				item:setEnable(true);
			end
			item:setLocation(-90, 291 - (idx - 1) * 46, 0);
			if arr[i].nextValue > 0 then
				str = LanUtil.formateStr(762025, arr[i].show_name, arr[i].showValue, arr[i].showNextValue);
			else
				str = LanUtil.formateStr(762024, arr[i].show_name, arr[i].showValue);
			end
			item:setData("common_altas_2", arr[i].attr_icon_2, str);
			idx = idx + 1;
		end
	end

	local len = self.attrItems:getSize();
	for i = idx + 1, len do
		self.attrItems[i]:setEnable(false);
	end
	return idx;
end

function Lua_TotemStrengthenPanel:updateMaterials(data)
	if self.screenData == data then
		return;
	end
	self.screenData = data;
	self.screenText.text = data[2];

	if self.materialArr then
		self.materialArr:clear();
	end
	self.materialArr = DataCenter.totemData:getStrengthenMaterials(self.data.unique_id, data[1]);
	if self.materialArr:getSize() <= 0 then
		self:showNone(true);
		if self.itemList then
			self.itemList:setEnable(false);
		end
	else
		self:showNone(false);
		if self.itemList == nil then
			self.itemList = Lua_DragList.new(self.content, 620, 315, Lua_AxisDefine.Vertical);
			self.itemList:setLocation(0, -160, 0);
			self.itemList:setListCell(Lua_TotemStrengthenItem, 124, 124, 5);
			self.itemList:setCellSpacing(0, 5);
			self.itemList.customParam = self.selectedDic;
			self.itemList.canLongPress = true;
		end
		self.itemList:setEnable(true);
		self.itemList:setArrayData(self.materialArr);
	end
end

function Lua_TotemStrengthenPanel:showNone(bValue)
	if bValue then
		if self.noneIcon == nil then
			self.noneIcon = UICreate.createImage(self.content, "/images/common/xui_common_widget_029.png", -12, -160, 0, 0);

			self.noneText = UICreate.createLabel(self.content, nil, -14, -93, 244, 31, 26);
			self.noneText.pivotValue = 0;
			self.noneText.fontName = Lua_MyUISettings.huakangFontName;
			self.noneText.lineSpacing = 1.2;
			self.noneText.alignmentValue = 0;
			self.noneText.horizontalOverflowValue = 0;
			self.noneText.verticalOverflowValue = 1;
			self.noneText.colorStr = Lua_ColorDefine.transColorStr("686868");
			self.noneText:setLangValue(762028);
		end
		self.noneIcon:setEnable(true);
		self.noneText:setEnable(true);
	else
		if self.noneIcon then
			self.noneIcon:setEnable(false);
			self.noneText:setEnable(false);
		end
	end
end

function Lua_TotemStrengthenPanel:onMaterialPlus(data)
	if self.bMaxLv then
		OperateAlert.showLangValue(762026);
		return;
	end

	if self.selectedDic[data.unique_id] == nil then
		self.selectedDic[data.unique_id] = 1;
		local exp, costNum = self:getMaterialExp(data);
		self.addExp = self.addExp + exp;
		self.returnCostNum = self.returnCostNum + costNum;
	else
		local count = self.selectedDic[data.unique_id];
		if count >= data.count then
			OperateAlert.showLangValue(762029);
		else
			count = count + 1;
			local exp, costNum = self:getMaterialExp(data);
			self.addExp = self.addExp + exp;
			self.returnCostNum = self.returnCostNum + costNum;
		end
		self.selectedDic[data.unique_id] = count;
	end

	self:updateAddExp();
end

function Lua_TotemStrengthenPanel:onMaterialLess(data)
	if self.selectedDic[data.unique_id] == nil then
		return;
	end

	local count = self.selectedDic[data.unique_id] - 1;
	self.selectedDic[data.unique_id] = count;
	if count <= 0 then
		self.selectedDic[data.unique_id] = nil;
	end
	local exp, costNum = self:getMaterialExp(data);
	self.addExp = self.addExp - exp;
	self.returnCostNum = self.returnCostNum - costNum;

	self:updateAddExp();
end

function Lua_TotemStrengthenPanel:getMaterialExp(data)
	local value = 0;
	local costNum = 0;
	local config;
	if data.strengthenLv > 0 then
		-- 强化的经验
		for i = 0, data.strengthenLv - 1 do
			config = DataCenter.totemUtil:getLevelConfig(data.id, i);
			if config then
				value = value + (config.exp or 0);

				if config.cost_item and #config.cost_item > 1 then
					costNum = costNum + config.cost_item[2] * config.exp;
				end
			end
		end
	end

	-- 强化溢出的经验
	if data.totem_info then
		value = value + data.totem_info.exp;
		config = DataCenter.totemUtil:getLevelConfig(data.id, data.strengthenLv);
		if config then
			if config.cost_item and #config.cost_item > 1 then
				costNum = costNum + config.cost_item[2] * data.totem_info.exp;
			end
			-- if config.return_cost_item and #config.return_cost_item > 1 then
			-- 	costNum = costNum + config.return_cost_item[2];
			-- end
		end
	end

	-- 自身提供的经验
	value = value + data.provideExp;
	return value, costNum;
end

function Lua_TotemStrengthenPanel:updateAddExp()
	self.itemList:updateShowList();

	if self.addExp > 0 and self.addExp >= self.needExp then
		local upLevel, leftExp, costNum = DataCenter.totemUtil:getUpLeveAndLeftExp(self.data.id, self.data.strengthenLv, self.curExp, self.addExp);
		self.upLevel = upLevel;
		self.showExp = leftExp;
		self.costNum = costNum - self.returnCostNum;
	else
		self.upLevel = self.data.strengthenLv;
		self.showExp = self.curExp + self.addExp;
		self.costNum = self.lvCfg.cost_item[2] * self.addExp - self.returnCostNum;
	end
	self:updateExpBar();
end

function Lua_TotemStrengthenPanel:updateExpBar()
	local lvCfg = DataCenter.totemUtil:getLevelConfig(self.data.id, self.upLevel);
	if lvCfg.exp == nil or lvCfg.exp == 0 then
		self.bMaxLv = true;
		self.showBar:setMaxValue(1);
		self.showBar:setValue(1);
		self.showBar:setLangValue(762027);
		self.costObject:SetActive(self.upLevel > self.data.strengthenLv);
	else
		self.bMaxLv = false;
		self.showBar:setMaxValue(lvCfg.exp);
		self.showBar:setValue(self.showExp);
		self.showBar:setText(LanUtil.formateStr(10044, tostring(self.showExp), tostring(lvCfg.exp)));
		self.costObject:SetActive(true);
	end

	if self.upLevel > self.data.strengthenLv then
		self.addLvText:setEnable(true);
		self.addLvText.text = LanUtil.formateStr(10049, tostring(self.upLevel));
	else
		self.addLvText:setEnable(false);
	end
	self:updateConsume();
end

function Lua_TotemStrengthenPanel:updateConsume()
	local itemCfg = getConfig("item", self.lvCfg.cost_item[1]);
	self.costIcon:setAltas(itemCfg.atlas, itemCfg.sprite);
	local haveNum = DataCenter.packData:getItemCountById(itemCfg.id);
	local costNum = (self.costNum < 0) and 0 or self.costNum;
	if haveNum >= costNum then
		self.costId = nil;
		haveNum = numberTrans(haveNum);
	else
		self.costId = itemCfg.id;
		haveNum = Lua_ColorDefine.getColorStr(Lua_ColorDefine.RED_STR, numberTrans(haveNum));
	end
	self.costText.text = LanUtil.formateStr(10044, haveNum, tostring(costNum));
	self.costText:resetSize();
	local width = 40 + self.costText.width;
	self.costBg:SetDimensions(width, 32);
	width = Mathf.Abs(width - 40) / 2;
	LuaUtil.setObjPos(self.costObject, 150 - width, -362, 0);
end

function Lua_TotemStrengthenPanel:onScreenClick(go)
	local param = { px = -150, py = -468, list = DataCenter.totemUtil.starScreen, selected = self.screenData };
	Lua_WindowUtil.openWin("Lua_TotemScreenWindow", Lua_WinParam.ACTION_OPEN, param);
end

function Lua_TotemStrengthenPanel:onChooseClick(go)
	if self.bMaxLv then
		OperateAlert.showLangValue(762026);
		return;
	end

	local len = self.materialArr:getSize();
	if len <= 0 then
		OperateAlert.showLangValue(762030);
		return;
	end

	local lvCfg = DataCenter.totemUtil:getLevelConfig(self.data.id, self.upLevel);
	local needExp = lvCfg.exp - self.showExp;
	local vo;
	local count;
	for i = 1, len do
		vo = DataCenter.packData:getItemVoByUnId(self.materialArr[i]);
		count = self.selectedDic[vo.unique_id];
		if count == nil then
			self.selectedDic[vo.unique_id] = 0;
			count = vo.count;
		else
			count = vo.count - count;
		end

		for j = 1, count do
			if needExp > 0 then
				self.selectedDic[vo.unique_id] = self.selectedDic[vo.unique_id] + 1;
				
				local exp, costNum = self:getMaterialExp(vo);
				needExp = needExp - exp;
				self.addExp = self.addExp + exp;
				self.returnCostNum = self.returnCostNum - costNum;
			else
				break;
			end
		end

		if needExp <= 0 then
			break;
		end
	end
	self:updateAddExp();
end

function Lua_TotemStrengthenPanel:onSureClick(go)
	if self.lvCfg.exp == nil or self.lvCfg.exp <= 0 then
		OperateAlert.showLangValue(762026);
		return;
	end

	if self.costId and self.costId > 0 then
		DataCenter.packUtil:openPathWindow(self.costId);
		return;
	end

	local num = 0;
	local bStarTips = false;
	local vo;
	for k, _ in pairs(self.selectedDic) do
		num = num + 1;
		vo = DataCenter.packData:getItemVoByUnId(k);
		if vo.main_type == Lua_PackDefine.TOTEM and vo.star >= 5 then
			bStarTips = true;
			break;
		end
	end

	if num == 0 then
		OperateAlert.showLangValue(762042);
		return;
	end

	if bStarTips then
		local param = { des = LanUtil.getValue(762031), btnType = 1, owner = self, sureFun = self.onStrengthen };
		Lua_WindowUtil.openWin("Lua_TipsWindow", Lua_WinParam.ACTION_OPEN, param);
		return;
	end

	self:onStrengthen();
end

function Lua_TotemStrengthenPanel:onStrengthen()
	local heroUid = DataCenter.totemData:getHeroUidByTotem(self.data.unique_id);
	Lua_ProxyManager.getProxy("Lua_TotemProxy"):sStrengthen(self.data.unique_id, self.selectedDic, heroUid);
end










Lua_TotemStrengthenItem = class("Lua_TotemStrengthenItem", Lua_ListCell)
function Lua_TotemStrengthenItem:ctor(p)
	self:superCall("ctor", p, "TotemStrengthenItem_skin");
end

function Lua_TotemStrengthenItem:buildShowItem()
	self:superCall("buildShowItem");

	self.itemIcon = Lua_ItemIcon.new(self.content);
	self.itemIcon:setSiblingIndex(0);

	self.btnLess:addMousDownFuntion(self, self.onLessDownClick);
	self.btnLess:addMouseUpFuntion(self, self.onLessUpClick);
end

function Lua_TotemStrengthenItem:dispose()
	self:removeLessTimer();
	if self.itemIcon then
		self.itemIcon:dispose();
		self.itemIcon = nil;
	end
	self.customParam = nil;
	self.data = nil;
	self:superCall("dispose");
end

function Lua_TotemStrengthenItem:setCustomParam(customParam)
	self.customParam = customParam;
end

function Lua_TotemStrengthenItem:setData(data)
	self.data = DataCenter.packData:getItemVoByUnId(data);
	self.itemIcon:setData(self.data);
	self.itemIcon:showNum(0);
	self:updateData();
end

function Lua_TotemStrengthenItem:updateData()
	local count = 0;
	if self.customParam ~= nil then
		count = self.customParam[self.data.unique_id];
	end
	self.selectedCount = count == nil and 0 or count;
	self.countText.text = LanUtil.formateStr(10044, tostring(self.selectedCount), tostring(self.data.count));
	if self.selectedCount > 0 then
		self.itemIcon:setMask(true);
		self.btnLess:setEnable(true);
	else
		self.itemIcon:setMask(false);
		self.btnLess:setEnable(false);
	end
end

function Lua_TotemStrengthenItem:onPressClick()
	Lua_MsgUtil.callFunc("TOTEM_STRENGTHEN_PLUS", self.data);
end

function Lua_TotemStrengthenItem:onLongPressClick()
	self:onPressClick();
end

function Lua_TotemStrengthenItem:onLessDownClick(go)
	self:startLessTimer();
end

function Lua_TotemStrengthenItem:onLessUpClick(go)
	self:removeLessTimer();
end

function Lua_TotemStrengthenItem:startLessTimer()
	if self.bLessTimer ~= true then
		self.bLessTimer = true;
		self.startLessTime = getTime();
		self:addTimer("Lua_TotemStrengthenItem", 0.01, self, self.onLessTimer);
	end
end

function Lua_TotemStrengthenItem:removeLessTimer()
    if self.bLessTimer == true then
        self.bLessTimer = false;
       	self:removeTimer(self, self.onLessTimer);
        if not self.bLongPress then
            self:onLess();
        end
    end
end

function Lua_TotemStrengthenItem:onLessTimer()
	if self.selectedCount <= 0 then
		self:removeLessTimer();
		return;
	end

	if getTime() - self.startLessTime > 0.3 then
		self.bLongPress = true;
		self:onLess();
	else
		self.bLongPress = false;
	end
end

function Lua_TotemStrengthenItem:onLess()
	Lua_MsgUtil.callFunc("TOTEM_STRENGTHEN_LESS", self.data);
end